<?php


/******************************************************************
	Our string manipulation and cleanup functions.
	These functions are available to any 
	object specific indexing functions
******************************************************************/

function removeTags($string) {

	$string = trim(ereg_replace("<([^>]|\n)*>"," ",$string));
	
	//remove blank spaces.  All of the other non-alphanum chars have been removed
	$string = str_replace("nbsp"," ",$string);

	return $string;
}

function tr_replace($keepIndex,$string) {

	//believe it or not, it's faster to dump text to a file, tr it, and then get the contents
	//than to pass the text right to php	
	$file = TMP_DIR."/".rand().".txt";
	$fp = fopen($file,"w");
	fwrite($fp,$string);
	fclose($fp);

	$string = `cat "$file" | tr -cd '$keepIndex\\r\\n\\t '`;

	@unlink($file);

	return $string;

}

function string_clean($passString) {

	$keepIndex = REGEXP_OPTION;
	
	//pass our text (or file) to tr to clean the text
	$string = tr_replace($keepIndex,$passString);

	//replace our tabs with spaces
	$string = str_replace("\t"," ",$string);
	$string = str_replace("\r"," ",$string);
	$string = str_replace("\n"," ",$string);

	//make all lowercase
	$string = strtolower($string);

	//clean out anything between a tag
	if ($cleanTags) $string = removeTags($string);
	
	//return here if we are using tsearch2
	if (defined("TSEARCH2_INDEX")) {

		//replace any 10 consecutive blank spaces with 1 space.  This should help keep tsearch2 under the 2k limit
		$string = str_replace("          "," ",$string);

		return $string;

	}

	/******************************************
		processing for the old index system
	******************************************/

	return uniqueString($string);	

}

//this strips all duplicate words from our string	
function uniqueString($string) {

	$wordArray = split(" ",$string);

	$wordArray = array_values(array_unique($wordArray));

	return implode(" ",$wordArray);

}


