#!/usr/local/bin/php

<?
/********************************************************
	This file will reset your files' md5 checksums
	 stored in docmgr.  Please set your dirPath below
	and run this script at the command line
	by typing "php checksum.php".
*********************************************************/

die("You must comment me out first\n");

//path to docmgr data directory
$dirPath = "/www/doc";

/*********************************************************
	don't modify anything below this line
*********************************************************/

define("ALT_FILE_PATH",$dirPath);

include($dirPath."/config/config.php");
include($dirPath."/include/postgresql.inc.php");
include($dirPath."/include/function.inc.php");
include($dirPath."/include/array_function.inc.php");

if (function_exists("simplexml_load_string")) include($dirPath."/include/simplexml.inc.php");
else include($dirPath."/include/legacyxml.inc.php");

//set our path defines
$filePath = getFilePath(FILE_DIR,$dirPath);

define("ALT_FILE_PATH",$dirPath);
define("DATA_DIR",$filePath."/data");
define("TMP_DIR",$filePath."/tmp");
define("THUMB_DIR",$filePath."/thumbnails");

include($dirPath."/include/common.inc.php");
include($dirPath."/modules/common/file_process.inc.php");
include($dirPath."/modules/common/file_content.inc.php");

$conn = db_connect(DBHOST,DBUSER,DBPASSWORD,DBPORT,DBNAME);

//first, update the md5sums for all files
$sql = "SELECT * FROM dm_file_history";
$list = list_result($conn,$sql);

echo "Updating file checksums\n";

for ($i=0;$i<$list["count"];$i++) {

    $id = $list[$i]["id"];

    $file = DATA_DIR."/".$id.".docmgr";
    $md5sum = md5_file($file);
    
    $sql = "UPDATE dm_file_history SET md5sum='$md5sum' WHERE id='$id'";
    if (!db_query($conn,$sql)) echo "There was an error updating file ".$id."\n";

}

echo "File checksum update complete\n";
echo "Fixing revision history\n";

//get all objects
$sql = "SELECT * FROM dm_object WHERE object_type='file'";
$list = list_result($conn,$sql);

for ($i=0;$i<$list["count"];$i++) {

  $objectId = $list[$i]["id"];

  //get all files belong to this object, with the highest version
  $sql = "SELECT * FROM dm_file_history WHERE object_id='$objectId' ORDER BY version DESC";
  $info = single_result($conn,$sql);

  $sql = "UPDATE dm_object SET version='".$info["version"]."' WHERE id='$objectId'";
  if (!db_query($conn,$sql)) echo "There was an error updating version info for ".$list[$i]["name"]."\n";

}

echo "Revision history update complete\n";




