<?php

//the rest of our includes with our base functions
include(WEBDAV_PATH."/config/config.php");
include(WEBDAV_PATH."/include/postgresql.inc.php");
include(WEBDAV_PATH."/include/function.inc.php");

//include our ldap file if set
if (defined("USE_LDAP")) include(WEBDAV_PATH."/config/ldap-config.php");

//set our path defines
$filePath = getFilePath(FILE_DIR,WEBDAV_PATH);

define("DATA_DIR",$filePath."/data");
define("TMP_DIR",$filePath."/tmp");
define("THUMB_DIR",$filePath."/thumbnails");

//our alternate file path for our extensions.xml file
define("ALT_FILE_PATH",WEBDAV_PATH);

include(WEBDAV_PATH."/include/array_function.inc.php");
include(WEBDAV_PATH."/include/date_function.inc.php");
include(WEBDAV_PATH."/include/module.inc.php");
include(WEBDAV_PATH."/app/common.inc.php");
include(WEBDAV_PATH."/app/object.inc.php");
include(WEBDAV_PATH."/app/search_function.inc.php");

//include xml parser.  Use simplexml if available
if (function_exists("simplexml_load_string")) include(WEBDAV_PATH."/include/simplexml.inc.php");
else include(WEBDAV_PATH."/include/legacyxml.inc.php");

if (defined("USE_LDAP")) include(WEBDAV_PATH."/include/ldap.inc.php");
else include(WEBDAV_PATH."/include/db.inc.php");

//make our request variables safe
sanitizeRequest();

$conn = db_connect(DBHOST,DBUSER,DBPASSWORD,DBPORT,DBNAME);

$_SESSION["conn"] = $conn;

setPermDefines();
setCustomPermDefines();

//configure DocMGR to use avail external apps
setExternalApps();

//load our modules
//Get our site layout if we have not already
if ($_SESSION["siteModList"] && $_SESSION["siteModInfo"] && !defined("DEV_MODE")) {
	$siteModList = &$_SESSION["siteModList"];
	$siteModInfo = &$_SESSION["siteModInfo"];
}
else {
	$siteModArr = loadSiteStructure(WEBDAV_PATH."/modules/center/");
	$_SESSION["siteModList"] = $siteModArr["list"];
	$_SESSION["siteModInfo"] = $siteModArr["info"];
	$siteModList = &$_SESSION["siteModList"];
	$siteModInfo = &$_SESSION["siteModInfo"];
}

//load our objects
loadObjects();

if ($_SESSION["user_id"]) {

	define("USER_ID",$_SESSION["user_id"]);

	//set the bitset info for our permissions
	include(WEBDAV_PATH."/auth/function.inc.php");
	userPermSet($conn,$_SESSION["user_id"],$_SESSION["user_authid"]);

}


//get all our categories put in an array for us to use later
$sql = "SELECT * FROM dm_view_collections ORDER BY id";
$_SESSION["catList"] = total_result($_SESSION["conn"],$sql);
